/*
* 07/08/2003 - 19:09:03
*
* TSTDictionary.java - 
* Copyright (C) 2003 Ashwin Jayaprakash
* ashwinjay@rediffmail.com
* www.javaforu.com
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
package searchassist.ui;

import javax.swing.JTextArea;
import javax.swing.JTextField;

import com.wallyflint.util.TernarySearchTree;

import com.mattwelsh.appframework.ui.AutoCompleteDictionary;

/**
 * @author Ashwin Jayaprakash
 */
public class TSTDictionary implements AutoCompleteDictionary
{
    private TernarySearchTree tst;
    private JTextField textField;
    private JTextArea textArea;

    /**
     * Constructor for TSTDictionary.
     */
    public TSTDictionary(TernarySearchTree tree, JTextField txtField, JTextArea txtArea)
    {
        tst = tree;
        textField = txtField;
        textArea = txtArea;
    } //end constr

    /**
     * @see com.mattwelsh.appframework.ui.AutoCompleteDictionary#addEntry(String)
     */
    public void addEntry(String s)
    {
    }

    /**
     * @see com.mattwelsh.appframework.ui.AutoCompleteDictionary#removeEntry(String)
     */
    public boolean removeEntry(String s)
    {
        return false;
    }

    /**
     * @see com.mattwelsh.appframework.ui.AutoCompleteDictionary#lookup(String)
     */
    public String lookup(String s)
    {
        String textFieldContents = textField.getText();
        if (textFieldContents == "" || textFieldContents == null)
        {
            return null;
        } //end if

        String matchingKeys = tst.matchPrefixString(textFieldContents);
        textArea.setText(matchingKeys);

        String match = tst.matchPrefixString(textFieldContents, 1);

        if (match != null)
        {
            if (match == "")
            {
                match = s;
            } //end inner if
            else
            {
                int markerLocation = match.indexOf(TernarySearchTree.MARKER_HIT_OPEN) - 1;
                if (markerLocation > 0)
                {
                    match = match.substring(0, markerLocation);
                } //end innermost if                
            } //end inner else
        } //end if

        return match;
    }

} //end class
